/* IMPORTANTE: Es necesario estar conectado con el usuario PFGBDJBD con password PFGBDJBD */
/* ----------  antes de lanzar la ejecucion de este script                                */

/*****************************************************************************/
/*                          BORRADO DE TABLAS                                */
/*****************************************************************************/

DROP TABLE TFGBDJBD.DISTRIBUIDOR CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.ENVASE CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.ESTADO CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.MARCA CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.PAIS CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.PRESENTACION CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.FORMATO CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.PRODUCTO CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.HOMOLOGACION CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.REGISTRO CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.LOG CASCADE CONSTRAINTS;

/*****************************************************************************/
/*                         BORRADO DE SECUENCIAS                             */
/*****************************************************************************/

DROP SEQUENCE SEQ_LOG;
DROP SEQUENCE SEQ_DISTRIBUIDOR;
DROP SEQUENCE SEQ_ENVASE;
DROP SEQUENCE SEQ_ESTADO;
DROP SEQUENCE SEQ_FORMATO;
DROP SEQUENCE SEQ_MARCA;
DROP SEQUENCE SEQ_PAIS;
DROP SEQUENCE SEQ_PRESENTACION;
DROP SEQUENCE SEQ_PRODUCTO;

/*****************************************************************************/
/*                          CREACION DE TABLAS                               */
/*****************************************************************************/


/****************** 1) CREACION DE TABLA: DISTRIBUIDOR ***********************/
CREATE TABLE TFGBDJBD.DISTRIBUIDOR
(
  IDDISTRIBUIDOR  INTEGER                       NOT NULL,
  NOMBRE          NVARCHAR2(50)                 NOT NULL,
  DIRECCION       NVARCHAR2(50),
  TELEFONO        CHAR(9 CHAR),
  FECHABAJA       DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.DISTRIBUIDOR_PK ON TFGBDJBD.DISTRIBUIDOR
(IDDISTRIBUIDOR)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.DISTRIBUIDOR ADD (
  CONSTRAINT DISTRIBUIDOR_PK
  PRIMARY KEY
  (IDDISTRIBUIDOR)
  USING INDEX TFGBDJBD.DISTRIBUIDOR_PK
  ENABLE VALIDATE);

/******************** 2) CREACION DE TABLA: ENVASE ***************************/

CREATE TABLE TFGBDJBD.ENVASE
(
  IDENVASE   INTEGER                            NOT NULL,
  NOMBRE     NVARCHAR2(50)                      NOT NULL,
  FECHABAJA  DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.ENVASE_PK ON TFGBDJBD.ENVASE
(IDENVASE)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE TFGBDJBD.ENVASE ADD (
  CONSTRAINT ENVASE_PK
  PRIMARY KEY
  (IDENVASE)
  USING INDEX TFGBDJBD.ENVASE_PK
  ENABLE VALIDATE);

/******************** 3) CREACION DE TABLA: ESTADO ***************************/

CREATE TABLE TFGBDJBD.ESTADO
(
  IDESTADO   INTEGER                            NOT NULL,
  NOMBRE     NVARCHAR2(50)                      NOT NULL,
  FECHABAJA  DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.ESTADO_PK ON TFGBDJBD.ESTADO
(IDESTADO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE TFGBDJBD.ESTADO ADD (
  CONSTRAINT ESTADO_PK
  PRIMARY KEY
  (IDESTADO)
  USING INDEX TFGBDJBD.ESTADO_PK
  ENABLE VALIDATE);

/********************* 4) CREACION DE TABLA: FORMATO *************************/

CREATE TABLE TFGBDJBD.FORMATO
(
  IDFORMATO  INTEGER                            NOT NULL,
  NOMBRE     NVARCHAR2(50)                      NOT NULL,
  IDENVASE   INTEGER                            NOT NULL,
  CANTIDAD   NVARCHAR2(50),
  FECHABAJA  DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.FORMATO_PK ON TFGBDJBD.FORMATO
(IDFORMATO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.FORMATO ADD (
  CONSTRAINT FORMATO_PK
  PRIMARY KEY
  (IDFORMATO)
  USING INDEX TFGBDJBD.FORMATO_PK
  ENABLE VALIDATE);

ALTER TABLE TFGBDJBD.FORMATO ADD (
  CONSTRAINT FK_FORMATO_REF_ENVASE 
  FOREIGN KEY (IDENVASE) 
  REFERENCES TFGBDJBD.ENVASE (IDENVASE)
  ENABLE VALIDATE);

/********************** 5) CREACION DE TABLA: PAIS ***************************/

CREATE TABLE TFGBDJBD.PAIS
(
  IDPAIS     INTEGER                            NOT NULL,
  NOMBRE     NVARCHAR2(50)                      NOT NULL,
  ISO3166    CHAR(2 CHAR)                       NOT NULL,
  FECHABAJA  DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.PAIS_PK ON TFGBDJBD.PAIS
(IDPAIS)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


CREATE UNIQUE INDEX TFGBDJBD.UN_PAIS_ISO3166 ON TFGBDJBD.PAIS
(ISO3166)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.PAIS ADD (
  CONSTRAINT PAIS_PK
  PRIMARY KEY
  (IDPAIS)
  USING INDEX TFGBDJBD.PAIS_PK
  ENABLE VALIDATE,
  CONSTRAINT UN_PAIS_ISO3166
  UNIQUE (ISO3166)
  USING INDEX TFGBDJBD.UN_PAIS_ISO3166
  ENABLE VALIDATE);


/********************** 6) CREACION DE TABLA: MARCA **************************/

CREATE TABLE TFGBDJBD.MARCA
(
  IDMARCA      INTEGER                          NOT NULL,
  NOMBRE       NVARCHAR2(50)                    NOT NULL,
  LABORATORIO  NVARCHAR2(50)                    DEFAULT 'NINGUNO',
  FECHABAJA    DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.MARCA_PK ON TFGBDJBD.MARCA
(IDMARCA)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.MARCA ADD (
  CONSTRAINT MARCA_PK
  PRIMARY KEY
  (IDMARCA)
  USING INDEX TFGBDJBD.MARCA_PK
  ENABLE VALIDATE);
 

/******************** 7) CREACION DE TABLA: PRESENTACION ********************/

CREATE TABLE TFGBDJBD.PRESENTACION
(
  IDPRESENTACION  INTEGER                       NOT NULL,
  NOMBRE          NVARCHAR2(50)                 NOT NULL,
  COLOR           NVARCHAR2(50)                 DEFAULT 'BLANCO',
  FECHABAJA       DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.PRESENTACION_PK ON TFGBDJBD.PRESENTACION
(IDPRESENTACION)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.PRESENTACION ADD (
  CONSTRAINT PRESENTACION_PK
  PRIMARY KEY
  (IDPRESENTACION)
  USING INDEX TFGBDJBD.PRESENTACION_PK
  ENABLE VALIDATE);

/******************** 8) CREACION DE TABLA: PRODUCTO *************************/

CREATE TABLE TFGBDJBD.PRODUCTO
(
  IDPRODUCTO      INTEGER                       NOT NULL,
  NOMBRE          NVARCHAR2(50)                 NOT NULL,
  FORMULA         NVARCHAR2(50)                 NOT NULL,
  IDFORMATO       INTEGER                       NOT NULL,
  IDMARCA         INTEGER                       NOT NULL,
  IDPRESENTACION  INTEGER                       NOT NULL,
  FECHABAJA       DATE
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.PRODUCTO_PK ON TFGBDJBD.PRODUCTO
(IDPRODUCTO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.PRODUCTO ADD (
  CONSTRAINT PRODUCTO_PK
  PRIMARY KEY
  (IDPRODUCTO)
  USING INDEX TFGBDJBD.PRODUCTO_PK
  ENABLE VALIDATE);

ALTER TABLE TFGBDJBD.PRODUCTO ADD (
  CONSTRAINT FK_PRODUCTO_REF_FORMATO 
  FOREIGN KEY (IDFORMATO) 
  REFERENCES TFGBDJBD.FORMATO (IDFORMATO)
  ENABLE VALIDATE,
  CONSTRAINT FK_PRODUCTO_REF_MARCA 
  FOREIGN KEY (IDMARCA) 
  REFERENCES TFGBDJBD.MARCA (IDMARCA)
  ENABLE VALIDATE,
  CONSTRAINT FK_PRODUCTO_REF_PRESENTACION 
  FOREIGN KEY (IDPRESENTACION) 
  REFERENCES TFGBDJBD.PRESENTACION (IDPRESENTACION)
  ENABLE VALIDATE);

/******************** 9) CREACION DE TABLA: HOMOLOGACION ********************/
 
CREATE TABLE TFGBDJBD.HOMOLOGACION
(
  IDPAIS             INTEGER                    NOT NULL,  
  IDDISTRIBUIDOR     INTEGER                    NOT NULL,
  IDPRODUCTO         INTEGER                    NOT NULL,
  FECHAHOMOLOGACION  DATE                       DEFAULT SYSDATE               NOT NULL,
  DESCRIPCION        NVARCHAR2(50)
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.HOMOLOGACION_PK ON TFGBDJBD.HOMOLOGACION
(IDPAIS, IDDISTRIBUIDOR, IDPRODUCTO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.HOMOLOGACION ADD (
  CONSTRAINT HOMOLOGACION_PK
  PRIMARY KEY
  (IDPAIS, IDDISTRIBUIDOR, IDPRODUCTO)
  USING INDEX TFGBDJBD.HOMOLOGACION_PK
  ENABLE VALIDATE);

ALTER TABLE TFGBDJBD.HOMOLOGACION ADD (
  CONSTRAINT FK_HOMOLOG_REF_PAIS 
  FOREIGN KEY (IDPAIS) 
  REFERENCES TFGBDJBD.PAIS (IDPAIS)
  ENABLE VALIDATE,  
  CONSTRAINT FK_HOMOLOG_REF_DISTRIBUIDOR 
  FOREIGN KEY (IDDISTRIBUIDOR) 
  REFERENCES TFGBDJBD.DISTRIBUIDOR (IDDISTRIBUIDOR)
  ENABLE VALIDATE,
  CONSTRAINT FK_HOMOLOG_REF_PRODUCTO 
  FOREIGN KEY (IDPRODUCTO) 
  REFERENCES TFGBDJBD.PRODUCTO (IDPRODUCTO)
  ENABLE VALIDATE);


/******************** 10) CREACION DE TABLA: REGISTRO *************************/

CREATE TABLE TFGBDJBD.REGISTRO
(
  IDPAIS           INTEGER                      NOT NULL,
  IDDISTRIBUIDOR   INTEGER                      NOT NULL,
  IDPRODUCTO       INTEGER                      NOT NULL,
  FECHASOLICITUD   DATE                         DEFAULT SYSDATE               NOT NULL,
  DESCRIPCION      VARCHAR2(50 CHAR)            NOT NULL,
  COSTE            FLOAT(2)                     DEFAULT 0                     NOT NULL,
  FECHARESOLUCION  DATE,
  IDESTADO         INTEGER                      DEFAULT 1                     NOT NULL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX TFGBDJBD.REGISTRO_PK ON TFGBDJBD.REGISTRO
(IDPAIS, IDDISTRIBUIDOR, IDPRODUCTO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.REGISTRO ADD (
  CONSTRAINT REGISTTRO_PK
  PRIMARY KEY
  (IDPAIS, IDDISTRIBUIDOR, IDPRODUCTO)
  USING INDEX TFGBDJBD.REGISTRO_PK
  ENABLE VALIDATE);

ALTER TABLE TFGBDJBD.REGISTRO ADD (
  CONSTRAINT REGISTTRO_ESTADO_FK 
  FOREIGN KEY (IDESTADO) 
  REFERENCES TFGBDJBD.ESTADO (IDESTADO)
  ENABLE VALIDATE,
  CONSTRAINT REGISTTRO_FK 
  FOREIGN KEY (IDPAIS, IDDISTRIBUIDOR, IDPRODUCTO) 
  REFERENCES TFGBDJBD.HOMOLOGACION (IDPAIS,IDDISTRIBUIDOR,IDPRODUCTO)
  ENABLE VALIDATE);


/******************** 11) CREACION DE TABLA: LOG *****************************/

CREATE TABLE TFGBDJBD.LOG
(
  IDLOG       INTEGER                           NOT NULL,
  FECHA       DATE                              DEFAULT SYSDATE               NOT NULL,
  SP          NVARCHAR2(50)                     NOT NULL,
  PARAMETROS  NVARCHAR2(300),
  RSP         NVARCHAR2(150)                    NOT NULL,
  ERRORCODE   INTEGER
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.LOG_PK ON TFGBDJBD.LOG
(IDLOG)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.LOG ADD (
  CONSTRAINT LOG_PK
  PRIMARY KEY
  (IDLOG)
  USING INDEX TFGBDJBD.LOG_PK
  ENABLE VALIDATE);


/*****************************************************************************/
/*                          CREACION DE SECUENCIAS                           */
/*****************************************************************************/
CREATE SEQUENCE TFGBDJBD.SEQ_DISTRIBUIDOR
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE TFGBDJBD.SEQ_ENVASE
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE TFGBDJBD.SEQ_ESTADO
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE TFGBDJBD.SEQ_FORMATO
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE TFGBDJBD.SEQ_LOG
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE TFGBDJBD.SEQ_MARCA
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE TFGBDJBD.SEQ_PAIS
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
CREATE SEQUENCE TFGBDJBD.SEQ_PRESENTACION
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

CREATE SEQUENCE TFGBDJBD.SEQ_PRODUCTO
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

  
/*****************************************************************************/
/*                     CREACION DE DESENCADENADORES                          */
/*****************************************************************************/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_DISTRIBUIDOR_BIOER
    Before Insert ON TFGBDJBD.DISTRIBUIDOR
    For Each Row
Begin
   Select SEQ_DISTRIBUIDOR.Nextval Into :New.IdDistribuidor
   From Dual;
End TRG_DISTRIBUIDOR_BIOER;
/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_ENVASE_BIOER
    Before Insert ON TFGBDJBD.ENVASE
    For Each Row
Begin
   Select SEQ_ENVASE.Nextval Into :New.IdEnvase
   From Dual;
End TRG_ENVASE_BIOER;
/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_ESTADO_BIOER
    Before Insert ON TFGBDJBD.ESTADO
    For Each Row
Begin
   Select SEQ_ESTADO.Nextval Into :New.IdEstado
   From Dual;
End TRG_ESTADO_BIOER;
/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_FORMATO_BIOER
    Before Insert ON TFGBDJBD.FORMATO
    For Each Row
Begin
   Select SEQ_FORMATO.Nextval Into :New.IdFormato
   From Dual;
End TRG_FORMATO_BIOER;
/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_LOG_BIOER
    Before Insert ON TFGBDJBD.LOG
    For Each Row
Begin
   Select SEQ_LOG.Nextval Into :New.IDLOG
   From Dual;
End TRG_LOG_BIOER;
/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_MARCA_BIOER
    Before Insert ON TFGBDJBD.MARCA
    For Each Row
Begin
   Select SEQ_MARCA.Nextval Into :New.IdMarca
   From Dual;
End TRG_MARCA_BIOER;
/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_PAIS_BIOER
    Before Insert ON TFGBDJBD.PAIS
    For Each Row
Begin
   Select SEQ_PAIS.Nextval Into :New.IdPais
   From Dual;
End TRG_PAIS_BIOER;
/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_PRESENTACION_BIOER
    Before Insert ON TFGBDJBD.PRESENTACION
    For Each Row
Begin
   Select SEQ_PRESENTACION.Nextval Into :New.IdPresentacion
   From Dual;
End TRG_PRESENTACION_BIOER;
/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_PRODUCTO_BIOER
    Before Insert ON TFGBDJBD.PRODUCTO
    For Each Row
Begin
   Select SEQ_PRODUCTO.Nextval Into :New.IdProducto
   From Dual;
End TRG_PRODUCTO_BIOER;
/

/*****************************************************************************/
/*                 CREACION DE FUNCIONES Y PROC. ALMACENADOS                 */
/*****************************************************************************/


/*******************************************************************************
Nombre :   SP_PKBD_PAIS_INS
Paquete:   PKBDINS
Funcion:   Da de alta un nuevo pais
********************************************************************************/
Create Or Replace Procedure SP_PKBD_PAIS_INS (
  pNombre In PAIS.Nombre%Type,
  pISO3166 In PAIS.ISO3166%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pNombre=' || pNombre || ' pISO3166=' || pISO3166;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.PAIS(Nombre, ISO3166) VALUES (pNombre, pISO3166);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);

  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_PAIS_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de un pais
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_PAIS_UPD (
  pIdPais In PAIS.IdPais%Type,
  pNombre In PAIS.Nombre%Type,
  pISO3166 In PAIS.ISO3166%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdPais=' || pIdPais || ' pNombre=' || pNombre || ' pISO3166=' || pISO3166;
  Rsp := 'OK';

  -- Actualiza los datos del pais
  UPDATE TFGBDJBD.PAIS SET Nombre = pNombre, ISO3166 = pISO3166 WHERE IdPais = pIdPais;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Pais Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_PAIS_DEL
Paquete:   PKBDUPD
Funcion:   Elimina un pais (Baja Lgica)
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_PAIS_DEL (
  pIdPais in PAIS.IdPais%type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
Err_homologado Exception;
err_code Integer;
cuantas Number;

Begin
   
   param_input := 'pIdPais=' || pIdPais;
   Rsp := 'OK';

   SELECT Count(*) INTO cuantas FROM TFGBDJBD.HOMOLOGACION WHERE IdPais = pIdPais;
   
   IF (cuantas > 0) THEN 
     Raise Err_homologado;
   END IF;
   

   UPDATE TFGBDJBD.PAIS SET FechaBaja = SYSTIMESTAMP WHERE IdPais = pIdPais AND FechaBaja IS Null;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;   

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Pais Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_homologado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado denegado. El pas se encuentra homologado actualmente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_ENVASE_INS
Paquete:   PKBDINS
Funcion:   Da de alta un nuevo envase
********************************************************************************/
Create Or Replace Procedure SP_PKBD_ENVASE_INS (
  pNombre In ENVASE.Nombre%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pNombre='|| pNombre;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.ENVASE(Nombre) VALUES (pNombre);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_ENVASE_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de un envase
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_ENVASE_UPD (
  pIdEnvase In ENVASE.IdEnvase%Type,
  pNombre In ENVASE.Nombre%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdEnvase=' || pIdEnvase || ': pNombre=' || pNombre;
  Rsp := 'OK';

  -- Actualiza los datos del envase
  UPDATE TFGBDJBD.ENVASE SET Nombre = pNombre WHERE IdEnvase = pIdEnvase;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);    
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Envase Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_ENVASE_DEL
Paquete:   PKBDUPD
Funcion:   Elimina un envase (Baja Lgica)
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_ENVASE_DEL (
  pIdEnvase in ENVASE.IdEnvase%type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
Err_formato Exception;
err_code Integer;
cuantas Number;

Begin
   param_input := 'pIdEnvase=' || pIdEnvase;
   Rsp := 'OK';

   SELECT Count(*) INTO cuantas FROM TFGBDJBD.FORMATO WHERE IdEnvase = pIdEnvase AND FechaBaja IS Null;
   
   IF (cuantas > 0) THEN 
     Raise Err_formato;
   END IF;
   
   UPDATE TFGBDJBD.ENVASE SET FechaBaja = SYSTIMESTAMP WHERE IdEnvase = pIdEnvase AND FechaBaja IS Null;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Envase Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_formato THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado denegado. El envase es utilizado en almenos un formato actualmente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_DISTRIBUIDOR_INS
Paquete:   PKBDINS
Funcion:   Da de alta un nuevo distribuidor
********************************************************************************/
Create Or Replace Procedure SP_PKBD_DISTRIBUIDOR_INS (
  pNombre In DISTRIBUIDOR.Nombre%Type,
  pDireccion In DISTRIBUIDOR.Direccion%Type,
  pTelefono In DISTRIBUIDOR.Telefono%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pNombre='|| pNombre || ' pDireccion=' || pDireccion || ' pTelefono=' || pTelefono;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.DISTRIBUIDOR(Nombre, Direccion, Telefono) VALUES (pNombre, pDireccion, pTelefono);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_DISTRIBUIDOR_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de un distribuidor
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_DISTRIBUIDOR_UPD (
  pIdDistribuidor In DISTRIBUIDOR.IdDistribuidor%Type,
  pNombre In DISTRIBUIDOR.Nombre%Type,
  pDireccion In DISTRIBUIDOR.Direccion%Type,
  pTelefono In DISTRIBUIDOR.Telefono%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdDistribuidor=' || pIdDistribuidor || ' pNombre='|| pNombre || ' pDireccion=' || pDireccion || ' pTelefono=' || pTelefono;
  Rsp := 'OK';

  -- Actualiza los datos del distribuidor
  UPDATE TFGBDJBD.DISTRIBUIDOR SET Nombre = pNombre, Direccion = pDireccion, Telefono = pTelefono WHERE IdDistribuidor = pIdDistribuidor;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Distribuidor Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;    
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_DISTRIBUIDOR_DEL
Paquete:   PKBDUPD
Funcion:   Elimina un distribuidor (Baja Lgica)
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_DISTRIBUIDOR_DEL (
  pIdDistribuidor in DISTRIBUIDOR.IdDistribuidor%type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
Err_homologado Exception;
err_code Integer;
cuantas Number;

Begin
   param_input := 'pIdDistribuidor=' || pIdDistribuidor;
   Rsp := 'OK';

   SELECT Count(*) INTO cuantas FROM TFGBDJBD.HOMOLOGACION WHERE IdDistribuidor = pIdDistribuidor;
   
   IF (cuantas > 0) THEN 
     Raise Err_homologado;
   END IF;

   UPDATE TFGBDJBD.DISTRIBUIDOR SET FechaBaja = SYSTIMESTAMP WHERE IdDistribuidor = pIdDistribuidor AND FechaBaja IS Null;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;   
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Distribuidor Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;   
  WHEN Err_homologado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado denegado. El distribuidor se encuentra homologado actualmente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_ESTADO_INS
Paquete:   PKBDINS
Funcion:   Da de alta un nuevo estado
********************************************************************************/
Create Or Replace Procedure SP_PKBD_ESTADO_INS (
  pNombre In ESTADO.Nombre%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
Err_registrado Exception;
err_code Integer;
cuantas Number;

Begin
  param_input := 'pNombre='|| pNombre;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.ESTADO(Nombre) VALUES (pNombre);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_ESTADO_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de un estado
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_ESTADO_UPD (
  pIdEstado In ESTADO.IdEstado%Type,
  pNombre In ESTADO.Nombre%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdEstado=' || pIdEstado || ': pNombre=' || pNombre;
  Rsp := 'OK';

  -- Actualiza los datos del estado
  UPDATE TFGBDJBD.ESTADO SET Nombre = pNombre WHERE IdEstado = pIdEstado;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;


Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Estado Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_ESTADO_DEL
Paquete:   PKBDUPD
Funcion:   Elimina un estado (Baja Lgica)
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_ESTADO_DEL (
  pIdEstado in ESTADO.IdEstado%type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
Err_registrado Exception;
err_code Integer;
cuantas Number;

Begin
   param_input := 'pIdEstado=' || pIdEstado;
   Rsp := 'OK';

   SELECT Count(*) INTO cuantas FROM TFGBDJBD.REGISTRO WHERE IdEstado = pIdEstado;
   
   IF (cuantas > 0) THEN 
     Raise Err_registrado;
   END IF;

   UPDATE TFGBDJBD.ESTADO SET FechaBaja = SYSTIMESTAMP WHERE IdEstado = pIdEstado AND FechaBaja IS Null;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Estado Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_registrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado denegado. El estado se encuentra en uso en al menos un registro sanitario actualmente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_FORMATO_INS
Paquete:   PKBDINS
Funcion:   Da de alta un nuevo formato
********************************************************************************/
Create Or Replace Procedure SP_PKBD_FORMATO_INS (
  pNombre In FORMATO.Nombre%Type,
  pIdEnvase In FORMATO.IdEnvase%Type,
  pCantidad In FORMATO.Cantidad%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pNombre='|| pNombre || ' pIdEnvase=' || pIdEnvase || ' pCantidad=' || pCantidad;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.FORMATO(Nombre, IdEnvase, Cantidad) VALUES (pNombre, pIdEnvase, pCantidad);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_FORMATO_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de un formato
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_FORMATO_UPD (
  pIdFormato In FORMATO.IdFormato%Type,
  pNombre In FORMATO.Nombre%Type,
  pIdEnvase In FORMATO.IdEnvase%Type,
  pCantidad In FORMATO.Cantidad%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
 param_input := 'pIdFormato=' || pIdFormato || ' pNombre='|| pNombre || ' pIdEnvase=' || pIdEnvase || ' pCantidad=' || pCantidad;
  Rsp := 'OK';

  -- Actualiza los datos del formato
  UPDATE TFGBDJBD.FORMATO SET Nombre = pNombre, IdEnvase = pIdEnvase, Cantidad = pCantidad WHERE IdFormato = pIdFormato;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Formato Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_FORMATO_DEL
Paquete:   PKBDUPD
Funcion:   Elimina un formato (Baja Lgica)
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_FORMATO_DEL (
  pIdFormato in FORMATO.IdFormato%type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
Err_usado Exception;
err_code Integer;
cuantas Number;

Begin
   param_input := 'pIdFormato=' || pIdFormato;
   Rsp := 'OK';

   SELECT Count(*) INTO cuantas FROM TFGBDJBD.PRODUCTO WHERE IdFormato = pIdFormato AND FechaBaja IS Null; 

   IF (cuantas > 0) THEN
       Raise Err_usado;
   END IF;
   

   UPDATE TFGBDJBD.FORMATO SET FechaBaja = SYSTIMESTAMP WHERE IdFormato = pIdFormato AND FechaBaja IS Null;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Formato Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_usado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado Denegado. El Formato se est utilizando en almenos un producto.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_HOMOLOGACION_INS
Paquete:   PKBDINS
Funcion:   Homologa un producto de un distribuidor en un pais
********************************************************************************/
Create Or Replace Procedure SP_PKBD_HOMOLOGAR_INS (
  pIdPais In HOMOLOGACION.IdPais%Type,
  pIdDistribuidor In HOMOLOGACION.IdDistribuidor%Type,
  pIdProducto In HOMOLOGACION.IdProducto%Type,
  pFechaHomologacion In HOMOLOGACION.FechaHomologacion%Type,
  pDescripcion In HOMOLOGACION.Descripcion%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pIdPais='|| pIdPais || ' pIdDistribuidor=' || pIdDistribuidor || ' pIdProducto=' || pIdProducto || ' pFechaHomologacion=' || pFechaHomologacion || ' pDescripcion=' || pDescripcion;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.HOMOLOGACION(IdPais, IdDistribuidor, IdProducto, FechaHomologacion, Descripcion) VALUES (pIdPais, pIdDistribuidor, pIdProducto, pFechaHomologacion, pDescripcion);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_HOMOLOGAR_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de una homologacion
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_HOMOLOGAR_UPD (
  pIdDistribuidor In HOMOLOGACION.IdDistribuidor%Type,
  pIdPais In HOMOLOGACION.IdPais%Type,
  pIdProducto In HOMOLOGACION.IdProducto%Type,
  pFechaHomologacion In HOMOLOGACION.FechaHomologacion%Type,
  pDescripcion In HOMOLOGACION.Descripcion%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdPais='|| pIdPais || ' pIdDistribuidor=' || pIdDistribuidor || ' pIdProducto=' || pIdProducto || ' pFechaHomologacion=' || pFechaHomologacion || ' pDescripcion=' || pDescripcion;
  Rsp := 'OK';

  -- Actualiza los datos de la homologacion
  UPDATE TFGBDJBD.HOMOLOGACION SET FechaHomologacion = pFechaHomologacion, Descripcion = pDescripcion  WHERE IdPais = pIdPais AND IdDistribuidor = pIdDistribuidor AND IdProducto = pIdProducto;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Homologacion Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_HOMOLOGAR_DEL
Paquete:   PKBDUPD
Funcion:   Elimina una homologacion
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_HOMOLOGAR_DEL (
  pIdDistribuidor In HOMOLOGACION.IdDistribuidor%Type,
  pIdPais In HOMOLOGACION.IdPais%Type,
  pIdProducto In HOMOLOGACION.IdProducto%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
err_code Integer;

Begin
   param_input := 'pIdPais='|| pIdPais || ' pIdDistribuidor=' || pIdDistribuidor || ' pIdProducto=' || pIdProducto;
   Rsp := 'OK';

   DELETE FROM HOMOLOGACION WHERE IdPais = pIdPais AND IdDistribuidor = pIdDistribuidor AND IdProducto = pIdProducto;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Homologacion Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_MARCA_INS
Paquete:   PKBDINS
Funcion:   Da de alta una nueva marca
********************************************************************************/
Create Or Replace Procedure SP_PKBD_MARCA_INS (
  pNombre In MARCA.Nombre%Type,
  pLaboratorio In MARCA.Laboratorio%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pNombre='|| pNombre || ' pLaboratorio='|| pLaboratorio;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.MARCA(Nombre, Laboratorio) VALUES (pNombre, pLaboratorio);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_MARCA_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de una marca
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_MARCA_UPD (
  pIdMarca In MARCA.IdMarca%Type,
  pNombre In MARCA.Nombre%Type,
  pLaboratorio In MARCA.Laboratorio%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdMarca=' || pIdMarca || 'pNombre='|| pNombre || ' pLaboratorio='|| pLaboratorio;
  Rsp := 'OK';

  -- Actualiza los datos de la marca
  UPDATE TFGBDJBD.MARCA SET Nombre = pNombre, Laboratorio = pLaboratorio WHERE IdMarca = pIdMarca;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;  

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Marca Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_MARCA_DEL
Paquete:   PKBDUPD
Funcion:   Elimina una marca (Baja Lgica)
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_MARCA_DEL (
  pIdMarca in MARCA.IdMarca%type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
Err_producto Exception;
err_code Integer;
cuantas Number;

Begin
   param_input := 'pIdMarca=' || pIdMarca;
   Rsp := 'OK';

   SELECT Count(*) INTO cuantas FROM TFGBDJBD.PRODUCTO WHERE IdMarca = pIdMarca AND FechaBaja IS Null; 

   IF (cuantas > 0) THEN
       Raise Err_producto;
   END IF;


   UPDATE TFGBDJBD.MARCA SET FechaBaja = SYSTIMESTAMP WHERE IdMarca = pIdMarca AND FechaBaja IS Null;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Marca Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_producto THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado denegado. La marca es utilizada actualmente por al menos un producto.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_PRESENTACION_INS
Paquete:   PKBDINS
Funcion:   Da de alta una nueva presentacion
********************************************************************************/
Create Or Replace Procedure SP_PKBD_PRESENTACION_INS (
  pNombre In PRESENTACION.Nombre%Type,
  pColor In PRESENTACION.Color%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pNombre='|| pNombre || ' pColor=' || pColor;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.PRESENTACION(Nombre, Color) VALUES (pNombre, pColor);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_PRESENTACION_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de una presentacion
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_PRESENTACION_UPD (
  pIdPresentacion In PRESENTACION.IdPresentacion%Type,
  pNombre In PRESENTACION.Nombre%Type,
  pColor In PRESENTACION.Color%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdPresentacion=' || pIdPresentacion || ': pNombre=' || pNombre || ' pColor=' || pColor;
  Rsp := 'OK';

  -- Actualiza los datos de la presentacion
  UPDATE TFGBDJBD.PRESENTACION SET Nombre = pNombre, Color = pColor WHERE IdPresentacion = pIdPresentacion;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);  
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Presentacion Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_PRESENTACION_DEL
Paquete:   PKBDUPD
Funcion:   Elimina una presentacion (Baja Lgica)
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_PRESENTACION_DEL (
  pIdPresentacion in PRESENTACION.IdPresentacion%type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
Err_producto Exception;
err_code Integer;
cuantas Number;

Begin
   param_input := 'pIdPresentacion=' || pIdPresentacion;
   Rsp := 'OK';

   SELECT Count(*) INTO cuantas FROM TFGBDJBD.PRODUCTO WHERE IdPresentacion = pIdPresentacion AND FechaBaja IS Null; 

   IF (cuantas > 0) THEN
       Raise Err_producto;
   END IF;

   UPDATE TFGBDJBD.PRESENTACION SET FechaBaja = SYSTIMESTAMP WHERE IdPresentacion = pIdPresentacion AND FechaBaja IS Null;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;      

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Presentacion Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_producto THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado denegado.La presentacion se esta usando en al menos un producto..';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_PRODUCTO_INS
Paquete:   PKBDINS
Funcion:   Da de alta un nuevo producto
********************************************************************************/
Create Or Replace Procedure SP_PKBD_PRODUCTO_INS (
  pNombre In PRODUCTO.Nombre%Type,
  pFormula In PRODUCTO.Formula%Type,
  pIdFormato In PRODUCTO.IdFormato%Type,
  pIdPresentacion In PRODUCTO.IdPresentacion%Type,
  pIdMarca In PRODUCTO.IdMarca%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pNombre='|| pNombre || ' pFormula=' || pFormula || ' pIdFormato=' || pIdFormato || ' pIdPresentacion=' || pIdPresentacion || ' pIdMarca=' || pIdMarca;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.PRODUCTO(Nombre, Formula, IdFormato, IdPresentacion, IdMarca) VALUES (pNombre, pFormula, pIdFormato, pIdPresentacion, pIdMarca);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_PRODUCTO_UPD
Paquete:   PKBDUPD
Funcion:   Modifica los datos de un producto
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_PRODUCTO_UPD (
  pIdProducto In PRODUCTO.IdProducto%Type,
  pNombre In PRODUCTO.Nombre%Type,
  pFormula In PRODUCTO.Formula%Type,
  pIdFormato In PRODUCTO.IdFormato%Type,
  pIdPresentacion In PRODUCTO.IdPresentacion%Type,
  pIdMarca In PRODUCTO.IdMarca%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdProducto=' || pIdProducto || ' pNombre='|| pNombre || ' pFormula=' || pFormula || ' pIdFormato=' || pIdFormato || ' pIdPresentacion=' || pIdPresentacion || ' pIdMarca=' || pIdMarca;
  Rsp := 'OK';

  -- Actualiza los datos del producto
  UPDATE TFGBDJBD.PRODUCTO SET
     Nombre = pNombre,
     Formula = pFormula,
     IdFormato = pIdFormato,
     IdPresentacion = pIdPresentacion,
     IdMarca = pIdMarca 
     WHERE IdProducto = pIdProducto;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;


  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);

  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Producto Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_PRODUCTO_DEL
Paquete:   PKBDUPD
Funcion:   Elimina un producto (Baja Lgica)
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_PRODUCTO_DEL (
  pIdProducto in PRODUCTO.IdProducto%type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300);  
Err_id_no_encontrado Exception;
Err_homologado Exception;
Err_registrado Exception;
err_code Integer;
homologados Number;
registrados Number;

Begin
   param_input := 'pIdProducto=' || pIdProducto;
   Rsp := 'OK';

   SELECT Count(*) INTO homologados FROM TFGBDJBD.HOMOLOGACION WHERE IdProducto = pIdProducto;
   
   IF (homologados > 0) THEN 
     Raise Err_homologado;
   END IF;
   
   SELECT Count(*) INTO registrados FROM TFGBDJBD.REGISTRO WHERE IdProducto = pIdProducto;
   
   IF (registrados > 0) THEN 
     Raise Err_registrado;
   END IF;

   UPDATE TFGBDJBD.PRODUCTO SET FechaBaja = SYSTIMESTAMP WHERE IdProducto = pIdProducto AND FechaBaja IS Null;

   err_code := SQLCODE;
   
   IF (SQL%ROWCOUNT = 0) THEN
       Raise Err_id_no_encontrado;
   END IF;
   
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);
   
   Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Producto Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_homologado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado Denegado. El Producto est homologado actualmente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_registrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Borrado Denegado. El producto tiene registros sanitarios asociados.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBD_REGISTRO_INS
Paquete:   PKBDINS
Funcion:   Da de alta un nuevo registro sanitario
********************************************************************************/
Create Or Replace Procedure SP_PKBD_REGISTRAR_INS (
  pIdPais In REGISTRO.IdPais%Type,
  pIdDistribuidor In REGISTRO.IdDistribuidor%Type,
  pIdProducto In REGISTRO.IdProducto%Type,
  pDescripcion In REGISTRO.Descripcion%Type,
  pCoste In REGISTRO.Coste%Type,
  Rsp Out Nocopy Varchar2)
Is

param_input Varchar2(300);  
err_code Integer;

Begin
  param_input := 'pIdPais=' || pIdPais || ' pIdDistribuidor=' || pIdDistribuidor || ' pIdProducto=' || pIdProducto || ' pDescripcion=' || pDescripcion || ' pCoste=' || pCoste;
  Rsp := 'OK';
  
  INSERT INTO TFGBDJBD.REGISTRO(IdPais, IdDistribuidor, IdProducto, Descripcion, Coste) VALUES (pIdPais, pIdDistribuidor, pIdProducto, pDescripcion, pCoste);
  err_code := SQLCODE;

  INSERT INTO TFGBDJBD.LOG(SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Inexistente. ';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN DUP_VAL_ON_INDEX THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Codigo Duplicado.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= SUBSTR('ERROR: ' || err_code ||' ' || SQLERRM ,1,300);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300),Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKBDUPD_REGISTRO_UPD
Paquete:   PKBDUPD
Funcion:   Actualiza solo la fecha de resolucion y el estado del registro
           solo si no han sido actualizados previamente
********************************************************************************/
Create Or Replace Procedure  SP_PKBD_REGISTRAR_UPD (
  pIdPais In REGISTRO.IdPais%Type,
  pIdDistribuidor In REGISTRO.IdDistribuidor%Type,
  pIdProducto In REGISTRO.IdProducto%Type,
  pFechaResolucion In REGISTRO.FechaResolucion%Type,
  pIdEstado In REGISTRO.IdEstado%Type,
  Rsp Out Nocopy Varchar2)
Is
param_input Varchar2(300); 
Err_id_no_encontrado exception;
err_code Integer;

Begin
  param_input := 'pIdPais=' || pIdPais || ' pIdDistribuidor=' || pIdDistribuidor || ' pIdProducto='|| pIdProducto || ' pFechaResolucion=' || pFechaResolucion || ' pIdEstado=' || pIdEstado;
  Rsp := 'OK';

  -- Actualiza los datos del registro
  UPDATE TFGBDJBD.REGISTRO SET
     FechaResolucion = pFechaResolucion,
     IdEstado = pIdEstado 
  WHERE IdPais = pIdPais AND IdDistribuidor = pIdDistribuidor AND IdProducto = pIdProducto AND FechaResolucion IS NULL;
  err_code := SQLCODE;
  
  IF (SQL%ROWCOUNT = 0) THEN 
     Raise Err_id_no_encontrado;
  END IF;

  INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);
  
  Commit;

Exception
  WHEN NO_DATA_FOUND THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Identificador Inexistente.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Err_id_no_encontrado THEN
    err_code := SQLCODE;
    Rsp:='ERROR: Registro Inexistente o ya tiene la resolucion.';
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
  WHEN Others THEN
    err_code := SQLCODE;
    Rsp:= Substr('ERROR: ' || Sqlcode ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(Rsp);
    Rollback;
    INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
    Commit;
End;
/

/*******************************************************************************
Nombre :   SP_PKDW_INF_DURMEDIAPAIS
Paquete:   PKDW
Funcion:   Obtiene una lista de registros sin resolucin de un pais determinado
********************************************************************************/
CREATE OR REPLACE PROCEDURE SP_PKBD_REGISTRO_INF(
  v_idPais PAIS.IDPAIS%TYPE,
  VRecordset Out SYS_REFCURSOR,
  Rsp Out Nocopy Varchar2)
IS
param_input Varchar2(300); 
err_code Integer;

BEGIN 
param_input := 'pIdPais=' || v_IdPais;
Rsp := 'OK';
OPEN VRecordset FOR 
  SELECT * FROM REGISTRO WHERE IDPAIS = v_idPais AND FECHARESOLUCION IS NULL ORDER BY 4;

err_code := SQLCODE;

INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
Dbms_output.Put_line(Rsp);

Exception
     WHEN OTHERS THEN
     err_code := SQLCODE;
     Rsp := SUBSTR(' ERROR: ' || Sqlcode ||' ' || SQLERRM, 1, 50);
     Dbms_output.Put_line(Rsp);
     ROLLBACK;
     INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
END;
/

COMMIT;

