/* IMPORTANTE: Es necesario estar conectado con el usuario PFGBDJBD con password PFGBDJBD */
/* ----------  antes de lanzar la ejecucion de este script                                */
set serveroutput on;

/*****************************************************************************/
/*                          BORRADO DE TABLAS                                */
/*****************************************************************************/

DROP TABLE TFGBDJBD.DW_H_TRAMITESPRODUCTOS CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.DW_H_TRAMITESPAISES CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.DW_H_PAISES CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.DW_H_FORMATOS CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.DW_D_PAIS CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.DW_D_PRODUCTO CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.DW_D_TIEMPO CASCADE CONSTRAINTS;
DROP TABLE TFGBDJBD.LOGDW CASCADE CONSTRAINTS;

/*****************************************************************************/
/*                         BORRADO DE SECUENCIAS                             */
/*****************************************************************************/

DROP SEQUENCE SEQ_DW_D_TIEMPO;
DROP SEQUENCE SEQ_DW_LOGDW;

/*****************************************************************************/
/*                          CREACION DE TABLAS                               */
/*****************************************************************************/


/******************** 1) CREACION DE TABLA: DW_D_PAIS ************************/

CREATE TABLE TFGBDJBD.DW_D_PAIS
(
  IDPAIS  INTEGER        NOT NULL,
  NOMBRE  NVARCHAR2(50)  NOT NULL,
  REGISTROS INTEGER      DEFAULT 0  NOT NULL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX TFGBDJBD.DW_D_PAIS_PK ON TFGBDJBD.DW_D_PAIS
(IDPAIS)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE TFGBDJBD.DW_D_PAIS ADD (
  CONSTRAINT DW_D_PAIS_PK  
  PRIMARY KEY
  (IDPAIS)
  USING INDEX TFGBDJBD.DW_D_PAIS_PK ENABLE VALIDATE);

/******************** 2) CREACION DE TABLA: DW_D_PRODUCTO ********************/

CREATE TABLE TFGBDJBD.DW_D_PRODUCTO
(
  IDPRODUCTO  INTEGER        NOT NULL,
  NOMBRE      NVARCHAR2(50)  NOT NULL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX TFGBDJBD.DW_D_PRODUCTO_PK ON TFGBDJBD.DW_D_PRODUCTO
(IDPRODUCTO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE TFGBDJBD.DW_D_PRODUCTO ADD (
  CONSTRAINT DW_D_PRODUCTO_PK  
  PRIMARY KEY
  (IDPRODUCTO)
  USING INDEX TFGBDJBD.DW_D_PRODUCTO_PK ENABLE VALIDATE);

/******************** 3) CREACION DE TABLA: DW_D_TIEMPO ********************/

CREATE TABLE TFGBDJBD.DW_D_TIEMPO
(
  IDTIEMPO   INTEGER                            NOT NULL,
  ANO        INTEGER                            NOT NULL,
  TRIMESTRE  INTEGER                            NOT NULL,
  MES        INTEGER                            NOT NULL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

CREATE UNIQUE INDEX TFGBDJBD.DW_D_TIEMPO_PK ON TFGBDJBD.DW_D_TIEMPO
(IDTIEMPO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;

ALTER TABLE TFGBDJBD.DW_D_TIEMPO ADD (
  CONSTRAINT DW_D_TIEMPO_PK  
  PRIMARY KEY
  (IDTIEMPO)
  USING INDEX TFGBDJBD.DW_D_TIEMPO_PK ENABLE VALIDATE);

/****************** 4) CREACION DE TABLA: DW_H_TRAMITESPRODUCTOS ******************/
CREATE TABLE DW_H_TRAMITESPRODUCTOS
(
  IDTIEMPO       INTEGER                        NOT NULL,
  IDPRODUCTO     INTEGER                        NOT NULL,
  REGISTROSTOTAL INTEGER                        DEFAULT 0                     NOT NULL,
  COSTESUM       FLOAT(2)                       DEFAULT 0                     NOT NULL,
  DURACIONSUM    FLOAT(2)                       DEFAULT 0                     NOT NULL,
  DURACIONMEDIA  FLOAT(2)                       GENERATED ALWAYS AS (DURACIONSUM/REGISTROSTOTAL) VIRTUAL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.DW_H_TRAMITESPRODUCTOS_PK ON TFGBDJBD.DW_H_TRAMITESPRODUCTOS
(IDTIEMPO, IDPRODUCTO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.DW_H_TRAMITESPRODUCTOS ADD (
  CONSTRAINT DW_H_TRAMITESPRODUCTOS_PK
  PRIMARY KEY
  (IDTIEMPO, IDPRODUCTO)
  USING INDEX TFGBDJBD.DW_H_TRAMITESPRODUCTOS_PK
  ENABLE VALIDATE);

ALTER TABLE TFGBDJBD.DW_H_TRAMITESPRODUCTOS ADD (
  CONSTRAINT DW_H_TRAMITESPRODUCTOS_FK1 
  FOREIGN KEY (IDTIEMPO) 
  REFERENCES TFGBDJBD.DW_D_TIEMPO (IDTIEMPO)
  ENABLE VALIDATE,
  CONSTRAINT DW_TRAMITESPRODUCTOS_FK2 
  FOREIGN KEY (IDPRODUCTO) 
  REFERENCES TFGBDJBD.DW_D_PRODUCTO (IDPRODUCTO)
  ENABLE VALIDATE);
/

/****************** 5) CREACION DE TABLA: DW_H_TRAMITESPAISES ******************/

CREATE TABLE TFGBDJBD.DW_H_TRAMITESPAISES
(
  IDTIEMPO       INTEGER                        NOT NULL,
  IDPAIS         INTEGER                        NOT NULL,
  REGISTROSTOTAL INTEGER                        DEFAULT 0                     NOT NULL,
  COSTESUM       FLOAT(2)                       DEFAULT 0                     NOT NULL,
  DURACIONSUM    FLOAT(2)                       DEFAULT 0                     NOT NULL,
  DURACIONMEDIA  FLOAT(2)                       GENERATED ALWAYS AS (DURACIONSUM/REGISTROSTOTAL) VIRTUAL,
  REGISTROSMEDIA FLOAT(2)                       DEFAULT 0                     NOT NULL,
  COSTEMEDIA     FLOAT(2)                       GENERATED ALWAYS AS (COSTESUM/REGISTROSTOTAL) VIRTUAL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.DW_H_TRAMITESPAISES_PK ON TFGBDJBD.DW_H_TRAMITESPAISES
(IDTIEMPO, IDPAIS)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.DW_H_TRAMITESPAISES ADD (
  CONSTRAINT DW_H_TRAMITESPAISES_PK
  PRIMARY KEY
  (IDTIEMPO, IDPAIS)
  USING INDEX TFGBDJBD.DW_H_TRAMITESPAISES_PK
  ENABLE VALIDATE);

ALTER TABLE TFGBDJBD.DW_H_TRAMITESPAISES ADD (
  CONSTRAINT DW_H_TRAMITESPAISES_FK1 
  FOREIGN KEY (IDTIEMPO) 
  REFERENCES TFGBDJBD.DW_D_TIEMPO (IDTIEMPO)
  ENABLE VALIDATE,
  CONSTRAINT DW_TRAMITESPAISES_FK2 
  FOREIGN KEY (IDPAIS) 
  REFERENCES TFGBDJBD.DW_D_PAIS (IDPAIS)
  ENABLE VALIDATE);
/

/****************** 6) CREACION DE TABLA: DW_H_FORMATOS ******************/

CREATE TABLE TFGBDJBD.DW_H_FORMATOS
(
  IDTIEMPO       INTEGER                        NOT NULL,
  TOTAL          INTEGER                        DEFAULT 0                     NOT NULL,
  REGISTRADOS    INTEGER                        DEFAULT 0                     NOT NULL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.DW_H_FORMATOS_PK ON TFGBDJBD.DW_H_FORMATOS
(IDTIEMPO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.DW_H_FORMATOS ADD (
  CONSTRAINT DW_H_FORMATOS_PK
  PRIMARY KEY
  (IDTIEMPO)
  USING INDEX TFGBDJBD.DW_H_FORMATOS_PK
  ENABLE VALIDATE);

ALTER TABLE TFGBDJBD.DW_H_FORMATOS ADD (
  CONSTRAINT DW_H_FORMATOS_FK1 
  FOREIGN KEY (IDTIEMPO) 
  REFERENCES TFGBDJBD.DW_D_TIEMPO (IDTIEMPO)
  ENABLE VALIDATE);
/

/****************** 7) CREACION DE TABLA: DW_H_PAISES ******************/

CREATE TABLE TFGBDJBD.DW_H_PAISES
(
  IDTIEMPO       INTEGER                        NOT NULL,
  TOTAL          INTEGER                        DEFAULT 0                     NOT NULL,
  CONDISTRIBUIDOR INTEGER                       DEFAULT 0                     NOT NULL
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.DW_H_PAISES_PK ON TFGBDJBD.DW_H_PAISES
(IDTIEMPO)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.DW_H_PAISES ADD (
  CONSTRAINT DW_H_PAISES_PK
  PRIMARY KEY
  (IDTIEMPO)
  USING INDEX TFGBDJBD.DW_H_PAISES_PK
  ENABLE VALIDATE);

ALTER TABLE TFGBDJBD.DW_H_PAISES ADD (
  CONSTRAINT DW_H_PAISES_FK1 
  FOREIGN KEY (IDTIEMPO) 
  REFERENCES TFGBDJBD.DW_D_TIEMPO (IDTIEMPO)
  ENABLE VALIDATE);
/
/******************** 8) CREACION DE TABLA: LOG *****************************/

CREATE TABLE TFGBDJBD.LOGDW
(
  IDLOG       INTEGER                           NOT NULL,
  FECHA       DATE                              DEFAULT SYSDATE               NOT NULL,
  SP          NVARCHAR2(50)                     NOT NULL,
  PARAMETROS  NVARCHAR2(300),
  RSP         NVARCHAR2(150)                    NOT NULL,
  ERRORCODE   INTEGER
)
TABLESPACE USERS
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX TFGBDJBD.LOGDW_PK ON TFGBDJBD.LOGDW
(IDLOG)
LOGGING
TABLESPACE USERS
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            NEXT             1M
            MAXSIZE          UNLIMITED
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE TFGBDJBD.LOGDW ADD (
  CONSTRAINT LOGDW_PK
  PRIMARY KEY
  (IDLOG)
  USING INDEX TFGBDJBD.LOGDW_PK
  ENABLE VALIDATE);

/*****************************************************************************/
/*                          CREACION DE SECUENCIAS                           */
/*****************************************************************************/
CREATE SEQUENCE TFGBDJBD.SEQ_DW_D_TIEMPO
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
  CREATE SEQUENCE TFGBDJBD.SEQ_DW_LOGDW
  START WITH 1
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
/*****************************************************************************/
/*                     CREACION DE DESENCADENADORES                          */
/*****************************************************************************/

CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_DW_D_TIEMPO_BIOER
    BEFORE INSERT ON TFGBDJBD.DW_D_TIEMPO
    FOR EACH ROW
Begin
   Select SEQ_DW_D_TIEMPO.Nextval Into :New.IdTiempo
   From Dual;
End TRG_DW_D_TIEMPO_BIOER;
/
-- -------------------------------------------------------------
CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_LOGDW_BIOER
    Before Insert ON TFGBDJBD.LOGDW
    For Each Row
Begin
   Select SEQ_DW_LOGDW.Nextval Into :New.IDLOG
   From Dual;
End TRG_LOGDW_BIOER;
/
-- -------------------------------------------------------------
CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_PRODUCTO_AIUOER
    AFTER INSERT OR UPDATE ON TFGBDJBD.PRODUCTO
    REFERENCING OLD AS old NEW AS new 
    FOR EACH ROW

DECLARE
  v_tableName varchar2(50);
  v_idProducto PRODUCTO.IDPRODUCTO%TYPE;

BEGIN
    
  -- Obtenemos el nombre de la tabla asociada al trigger --
  SELECT table_name INTO v_tableName FROM user_triggers WHERE trigger_name= $$PLSQL_UNIT;
    
  IF INSERTING THEN
     BEGIN
        v_idProducto := -1;
        SELECT IdProducto INTO v_idProducto FROM DW_D_PRODUCTO WHERE IdProducto = :new.IDPRODUCTO; 
        UPDATE DW_D_PRODUCTO SET Nombre = :new.NOMBRE WHERE IDPRODUCTO = :new.IDPRODUCTO;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           IF (v_idProducto = -1) THEN
              INSERT INTO DW_D_PRODUCTO (IDPRODUCTO, NOMBRE) VALUES (:new.IDPRODUCTO, :new.NOMBRE);
           END IF;
     END;
     
  END IF;

  IF UPDATING THEN
     UPDATE DW_D_PRODUCTO SET Nombre = :new.NOMBRE WHERE IDPRODUCTO = :old.IDPRODUCTO;
  END IF;

END;
/
-- ------------------------------------------------------------
CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_PAIS_AIUOER
    AFTER INSERT OR UPDATE ON TFGBDJBD.PAIS
    REFERENCING OLD AS old NEW AS new 
    FOR EACH ROW

DECLARE
  v_ano     integer;
  v_trimestre     integer;
  v_mes     integer;
  v_idTiempo     integer;
  v_idPais PAIS.IDPAIS%TYPE;
  v_tieneDistribuidor boolean;

BEGIN

  -- Extraemos el ao y mes de la fecha actual --
  SELECT EXTRACT(Year FROM SYSDATE) INTO v_ano FROM DUAL;
  SELECT EXTRACT(Month FROM SYSDATE) INTO v_mes FROM DUAL;
        
  -- Calculo del trimestre --
  v_trimestre := TRUNC((v_mes + 2) / 3);

  -- Obtenemos el identificador de Tiempo correspondiente al mes y ao actual --
  BEGIN
     v_idTiempo := -1;
     SELECT IdTiempo INTO v_idTiempo FROM DW_D_TIEMPO WHERE Mes = v_mes AND Trimestre = v_trimestre AND Ano = v_ano;
     
  EXCEPTION 
     WHEN NO_DATA_FOUND THEN
        IF v_idTiempo = -1 THEN
           INSERT INTO DW_D_TIEMPO (Ano, Trimestre, Mes) VALUES (v_ano, v_trimestre, v_mes) RETURNING IdTiempo INTO v_idTiempo;
        END IF;
  END;
  
  -- Comprobamos si el pais tiene distribuidor --
  -- NOTA: Esta comprobacion no es necesaria ya que al ser insert aun no estar homologado y por tanto no tendra distribuidor
  --BEGIN
  --   v_idDistribuidor := -1;
  --   SELECT IdDistribuidor INTO v_idDistribuidor FROM HOMOLOGACION WHERE IdPais = :new.IdPais AND rownum = 1;
  --   v_tieneDistribuidor := TRUE;
  
  --EXCEPTION
  --   WHEN NO_DATA_FOUND THEN
        v_tieneDistribuidor := FALSE;
  --END;

  IF INSERTING THEN 
     BEGIN 
        -- Rellenamos la tabla de dimension de pais --
        BEGIN
        v_idPais := -1;
        SELECT IdPais INTO v_idPais FROM DW_D_PAIS WHERE IdPais = :new.IDPAIS; 
        UPDATE DW_D_PAIS SET 
           Nombre = :new.NOMBRE 
           WHERE IDPAIS = :new.IDPAIS;
        
        EXCEPTION
           WHEN NO_DATA_FOUND THEN
              IF (v_idPais = -1) THEN
                 INSERT INTO DW_D_PAIS (IDPAIS, NOMBRE) VALUES (:new.IDPAIS, :new.NOMBRE);
              END IF;
        END;
        
        -- Sincronizamos la informacin de los indicadores de la tabla de hechos DW_H_PAISES --
        --IF (v_tieneDistribuidor) THEN
        --    UPDATE DW_H_PAISES SET 
        --       Total = (Total + 1), 
        --       ConDistribuidor = (ConDistribuidor + 1) 
        --       WHERE IdTiempo = v_idTiempo;
        --ELSE 
            UPDATE DW_H_PAISES SET 
               Total = (Total + 1) 
               WHERE IdTiempo = v_idTiempo;
        --END IF;
        
        IF (SQL%ROWCOUNT = 0) THEN 
            --IF (v_tieneDistribuidor) THEN
            --    INSERT INTO DW_H_PAISES (IdTiempo, Total, ConDistribuidor) VALUES (v_idTiempo, 1, 1);
            --ELSE
               INSERT INTO DW_H_PAISES (IdTiempo, Total) VALUES (v_idTiempo, 1);
            --END IF;
        END IF;
                    
     END;
  END IF;
  
  IF UPDATING THEN
     BEGIN
        -- Actualizamos la tabla de dimension de pais --
        UPDATE DW_D_PAIS SET Nombre = :new.Nombre WHERE IdPais = :old.IdPais;
      
        -- Si ha efectuado un borrado lgico... --
        IF (:new.FechaBaja IS NOT NULL) THEN
           IF (v_tieneDistribuidor) THEN
              UPDATE DW_H_PAISES SET Total = (Total - 1), ConDistribuidor = (ConDistribuidor - 1) WHERE IdTiempo = v_idTiempo;    
           ELSE
              UPDATE DW_H_PAISES SET Total = (Total - 1) WHERE IdTiempo = v_idTiempo;    
           END IF;
        END IF;
     END;
  END IF;
  
END;
/
-- ------------------------------------------------------------
CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_FORMATO_AIUOER
    AFTER INSERT OR UPDATE ON FORMATO
    REFERENCING OLD AS old NEW AS new 
    FOR EACH ROW 

DECLARE
  v_ano     integer;
  v_trimestre     integer;
  v_mes     integer;
  v_idTiempo     integer;
  v_idProducto  integer;
  v_registrado  boolean;

BEGIN

  -- Extraemos el ao y mes de la fecha actual --
  SELECT EXTRACT(Year FROM SYSDATE) INTO v_ano FROM DUAL;
  SELECT EXTRACT(Month FROM SYSDATE) INTO v_mes FROM DUAL;
        
  -- Calculo del trimestre --
  v_trimestre := TRUNC((v_mes + 2) / 3);

  -- Obtenemos el identificador de Tiempo correspondiente al mes y ao actual --
  BEGIN
     v_idTiempo := -1;
     SELECT IdTiempo INTO v_idTiempo FROM DW_D_TIEMPO WHERE Mes = v_mes AND Trimestre = v_trimestre AND Ano = v_ano;
     
  EXCEPTION 
     WHEN NO_DATA_FOUND THEN
        IF v_idTiempo = -1 THEN
           INSERT INTO DW_D_TIEMPO (Ano, Trimestre, Mes) VALUES (v_ano, v_trimestre, v_mes) RETURNING IdTiempo INTO v_idTiempo;
        END IF;
  END;
  
  -- Comprobamos si alguno de los productos que han sido registrados presentan dicho formato --
  BEGIN
     v_idProducto := -1;
     SELECT P.IdProducto INTO v_idProducto 
       FROM REGISTRO R
       LEFT OUTER JOIN HOMOLOGACION H ON H.IdPais = R.IdPais AND H.IdDistribuidor = R.IdDistribuidor AND H.IdProducto = R.IdProducto
       LEFT OUTER JOIN PRODUCTO P ON P.IdProducto = H.IdProducto
       WHERE P.IdFormato = :new.IdFormato
       AND rownum = '1';
     v_registrado := TRUE;
  
  EXCEPTION
     WHEN NO_DATA_FOUND THEN
        v_registrado := FALSE;
  END;

  IF INSERTING THEN 
     BEGIN 
        -- Sincronizamos la informacin de los indicadores de la tabla de hechos DW_H_FORMATOS --
        IF (v_registrado) THEN
        UPDATE DW_H_FORMATOS SET Total = (Total + 1), Registrados = (Registrados + 1) WHERE IdTiempo = v_idTiempo;
        ELSE 
            UPDATE DW_H_FORMATOS SET Total = (Total + 1) WHERE IdTiempo = v_idTiempo;
        END IF;
        IF (SQL%ROWCOUNT = 0) THEN 
            IF (v_registrado) THEN
                INSERT INTO DW_H_FORMATOS (IdTiempo, Total, Registrados) VALUES (v_idTiempo, 1, 1);
            ELSE
               INSERT INTO DW_H_FORMATOS (IdTiempo, Total) VALUES (v_idTiempo, 1);
            END IF;
        END IF;            
     END;
  END IF;

  IF UPDATING THEN
     BEGIN
        -- Si ha efectuado un borrado lgico... --
        IF (:new.FechaBaja IS NOT NULL) THEN
           IF (v_registrado) THEN
              UPDATE DW_H_FORMATOS SET Total = (Total - 1), Registrados = (Registrados - 1) WHERE IdTiempo = v_idTiempo;    
           ELSE 
              UPDATE DW_H_FORMATOS SET Total = (Total - 1) WHERE IdTiempo = v_idTiempo;    
           END IF;
        END IF;
     END;
  END IF;
END;
/

-- ---------------------------------------------------------------------------
CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_BD_HOMOLOGACION_BIOER
    BEFORE INSERT ON HOMOLOGACION
    REFERENCING OLD AS old NEW AS new 
    FOR EACH ROW 

DECLARE
  v_ano         integer;
  v_trimestre   integer;
  v_mes         integer;
  v_idTiempo    integer;
  v_idPais      integer;
  v_estaHomologado  boolean;

BEGIN

  -- Extraemos el ao y mes de la fecha actual --
  SELECT EXTRACT(Year FROM SYSDATE) INTO v_ano FROM DUAL;
  SELECT EXTRACT(Month FROM SYSDATE) INTO v_mes FROM DUAL;
        
  -- Calculo del trimestre --
  v_trimestre := TRUNC((v_mes + 2) / 3);

  -- Obtenemos el identificador de Tiempo correspondiente al mes y ao actual --
  BEGIN
     v_idTiempo := -1;
     SELECT IdTiempo INTO v_idTiempo FROM DW_D_TIEMPO WHERE Mes = v_mes AND Trimestre = v_trimestre AND Ano = v_ano;
     
  EXCEPTION 
     WHEN NO_DATA_FOUND THEN
        IF v_idTiempo = -1 THEN
           INSERT INTO DW_D_TIEMPO (Ano, Trimestre, Mes) VALUES (v_ano, v_trimestre, v_mes) RETURNING IdTiempo INTO v_idTiempo;
        END IF;
  END;


  IF INSERTING THEN
     BEGIN
     
        -- Comprobamos si el pais ya esta homologado previamente --
        BEGIN
           v_idPais := -1;
           SELECT IdPais INTO v_idPais FROM HOMOLOGACION WHERE IdPais = :new.IdPais AND rownum = 1;
           v_estaHomologado := TRUE;
  
        EXCEPTION
           WHEN NO_DATA_FOUND THEN
                v_estaHomologado := FALSE;
        END;   
     
        -- actualizacion de los indicadores de la tabla DW_H_PAISES --
        -- Solo se incrementa si el pais aun no tiene ninguna homologacion --
        IF (NOT v_estaHomologado) THEN
            UPDATE DW_H_PAISES SET 
                Condistribuidor = Condistribuidor + 1
                WHERE IdTiempo = v_idTiempo;
           
            IF (SQL%ROWCOUNT = 0) THEN 
                INSERT INTO DW_H_PAISES (IdTiempo, Total, ConDistribuidor) VALUES (v_idTiempo, 1, 1);
            END IF;
        END IF;
        
     END;
  END IF;  

END;
/
-- ---------------------------------------------------
CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_REGISTRO_BIOER
    BEFORE INSERT ON REGISTRO
    REFERENCING OLD AS old NEW AS new 
    FOR EACH ROW 

DECLARE
  v_ano     integer;
  v_trimestre     integer;
  v_mes     integer;
  v_idTiempo     integer;
  v_idFormato    FORMATO.IDFORMATO%TYPE;
  v_idProducto   PRODUCTO.IDPRODUCTO%TYPE;
  v_flag         boolean;

BEGIN


  IF INSERTING THEN
     BEGIN
     
        -- Extraemos el ao y mes de la fecha actual --
        SELECT EXTRACT(Year FROM SYSDATE) INTO v_ano FROM DUAL;
        SELECT EXTRACT(Month FROM SYSDATE) INTO v_mes FROM DUAL;
        
        -- Calculo del trimestre --
        v_trimestre := TRUNC((v_mes + 2) / 3);

        -- Obtenemos el identificador de Tiempo correspondiente al mes y ao actual --
        BEGIN
            v_idTiempo := -1;
            SELECT IdTiempo INTO v_idTiempo FROM DW_D_TIEMPO WHERE Mes = v_mes AND Trimestre = v_trimestre AND Ano = v_ano;
     
        EXCEPTION 
            WHEN NO_DATA_FOUND THEN
            IF v_idTiempo = -1 THEN
                INSERT INTO DW_D_TIEMPO (Ano, Trimestre, Mes) VALUES (v_ano, v_trimestre, v_mes) RETURNING IdTiempo INTO v_idTiempo;
            END IF;
        END;
  
        -- Averiguamos el formato del producto que se quiere registrar --
        SELECT IdFormato INTO v_idFormato FROM PRODUCTO WHERE IdProducto = :new.IdProducto;
     
        -- Comprobamos si alguno de los productos ya registrados tiene el mismo formato --
        BEGIN
           v_idProducto := -1;
           SELECT R.IdProducto INTO v_idProducto 
             FROM REGISTRO R 
             LEFT OUTER JOIN PRODUCTO P ON P.IdProducto = R.IdProducto
             LEFT OUTER JOIN FORMATO F ON F.IdFormato = P.IdFormato 
             WHERE F.IdFormato = v_idFormato 
             AND rownum = 1;
           v_flag := TRUE;
  
        EXCEPTION
           WHEN NO_DATA_FOUND THEN
                v_flag := FALSE;
        END;   
     
        -- actualizamos los indicadores involucrados de la tabla DW_H_FORMATOS --
        -- NOTA: Incrementar solamente si no coincide con el formato de los productos que ya hay registrados
        IF (NOT v_flag) THEN
            UPDATE DW_H_FORMATOS SET Registrados = (Registrados + 1) WHERE IdTiempo = v_idTiempo;
        END IF;
        
     END;
  END IF;  
EXCEPTION
   WHEN NO_DATA_FOUND THEN
      Dbms_output.Put_line('No data found');
END;
/
-- ---------------------------------------------------
CREATE OR REPLACE TRIGGER TFGBDJBD.TRG_BD_REGISTRO_AIUOER
    AFTER INSERT OR UPDATE ON REGISTRO
    REFERENCING OLD AS old NEW AS new 
    FOR EACH ROW 

DECLARE
  v_ano     integer;
  v_trimestre     integer;
  v_mes     integer;
  v_idTiempo     integer;
  v_nombreProducto varchar2(50);
  v_nombrePais  varchar2(50);
  v_duracion DW_H_TRAMITESPAISES.DURACIONSUM%TYPE;
  v_registrosDelPais DW_D_PAIS.REGISTROS%TYPE;

BEGIN

  -- Extraemos el ao y mes de la fecha actual --
  SELECT EXTRACT(Year FROM SYSDATE) INTO v_ano FROM DUAL;
  SELECT EXTRACT(Month FROM SYSDATE) INTO v_mes FROM DUAL;
        
  -- Calculo del trimestre --
  v_trimestre := TRUNC((v_mes + 2) / 3);

  -- Obtenemos el identificador de Tiempo correspondiente al mes y ao actual --
  BEGIN
     v_idTiempo := -1;
     SELECT IdTiempo INTO v_idTiempo FROM DW_D_TIEMPO WHERE Mes = v_mes AND Trimestre = v_trimestre AND Ano = v_ano;
     
  EXCEPTION 
     WHEN NO_DATA_FOUND THEN
        IF v_idTiempo = -1 THEN
           INSERT INTO DW_D_TIEMPO (Ano, Trimestre, Mes) VALUES (v_ano, v_trimestre, v_mes) RETURNING IdTiempo INTO v_idTiempo;
        END IF;
  END;

  -- sincronizamos la tabla DW_D_PRODUCTO
  SELECT Nombre INTO v_nombreProducto FROM PRODUCTO WHERE IdProducto = :new.IdProducto;
  UPDATE DW_D_PRODUCTO SET Nombre = v_nombreProducto WHERE IdProducto = :new.IdProducto;
  IF (SQL%ROWCOUNT = 0) THEN 
     INSERT INTO DW_D_PRODUCTO (IdProducto, Nombre) VALUES (:new.IdProducto, v_nombreProducto);
  END IF;

  -- sincronizamos la tabla DW_D_PAIS
  SELECT Nombre INTO v_nombrePais FROM PAIS WHERE IdPais = :new.IdPais;
  UPDATE DW_D_PAIS SET Nombre = v_nombrePais WHERE IdPais = :new.IdPais;
  IF (SQL%ROWCOUNT = 0) THEN 
     INSERT INTO DW_D_PAIS (IdPais, Nombre) VALUES (:new.IdPais, v_nombrePais);
  END IF;


  IF INSERTING THEN
     BEGIN
        -- calculo de la nueva duracion --
        IF (:new.FechaResolucion IS NOT NULL) THEN
           v_duracion := (:new.FechaResolucion - :old.FechaSolicitud);
        ELSE  
           v_duracion := 0;
        END IF;
        
        -- obtenemos el total de registros del pais --
        SELECT Registros INTO v_registrosDelPais FROM DW_D_PAIS WHERE IdPais = :new.IdPais;
        
        -- actualizamos los indicadores involucrados de la tabla DW_H_TRAMITESPAISES -- 
        UPDATE DW_H_TRAMITESPAISES SET 
           RegistrosTotal = RegistrosTotal + 1,
           CosteSum = CosteSum + :new.Coste,
           DuracionSum = DuracionSum + v_duracion,
           RegistrosMedia = (v_registrosDelPais/v_idTiempo)
           WHERE IdTiempo = v_idTiempo 
           AND IdPais = :new.IdPais;
        
        IF (SQL%ROWCOUNT = 0) THEN 
           INSERT INTO DW_H_TRAMITESPAISES (IdTiempo, IdPais, RegistrosTotal, CosteSum, DuracionSum, RegistrosMedia) 
              VALUES (v_idTiempo, :new.IdPais, 1, :new.Coste, v_duracion, v_registrosDelPais);
        END IF;
  
        -- actualizamos los indicadores involucrados de la tabla DW_H_TRAMITESPRODUCTOS --
        UPDATE DW_H_TRAMITESPRODUCTOS SET 
           RegistrosTotal = RegistrosTotal + 1,
           CosteSum = CosteSum + :new.Coste,
           DuracionSum = DuracionSum + v_duracion
           WHERE IdTiempo = v_idTiempo AND IdProducto = :new.IdProducto;
        
        IF (SQL%ROWCOUNT = 0) THEN 
           INSERT INTO DW_H_TRAMITESPRODUCTOS (IdTiempo, IdProducto, RegistrosTotal, CosteSum, DuracionSum) 
              VALUES (v_idTiempo, :new.IdProducto, 1, :new.Coste, v_duracion);
        END IF;
        
        -- actualizamos el indicador que contabiliza los registros por pais en la tabla DW_D_PAIS --
        UPDATE DW_D_PAIS SET 
           Registros = (Registros + 1) 
           WHERE IdPais = :new.idPais;

     END;
  END IF;  

  IF UPDATING THEN 
     -- Solo tenemos que actualizar la duracion del registro --
     IF (:new.FechaResolucion IS NOT NULL) THEN
        BEGIN
           UPDATE DW_H_TRAMITESPRODUCTOS SET DuracionSum = DuracionSum + (:new.FechaResolucion - :old.FechaSolicitud) WHERE IdTiempo = v_idTiempo AND IdProducto = :new.IdProducto;    
           UPDATE DW_H_TRAMITESPAISES SET DuracionSum = DuracionSum + (:new.FechaResolucion - :old.FechaSolicitud) WHERE IdTiempo = v_idTiempo AND IdPais = :new.IdPais;
        END;     
     END IF;
  END IF;
END;
/

/*****************************************************************************/
/*                 CREACION DE FUNCIONES Y PROC. ALMACENADOS                 */
/*****************************************************************************/

/*******************************************************************************
Nombre :   SP_PKDW_INF_COSTEREGPROD
Paquete:   PKDW
Funcion:   Obtiene los productos que cuesta ms registrar
********************************************************************************/
CREATE OR REPLACE PROCEDURE SP_PKDW_INF_COSTEREGPROD(
  VRecordset Out SYS_REFCURSOR,
  Rsp Out Nocopy Varchar2)
IS

param_input Varchar2(300); 
err_code Integer;

BEGIN 
param_input := '' ;
Rsp := 'OK';

OPEN VRecordset FOR 
   SELECT T.Ano, P.IdProducto, P.Nombre As Producto, R.CosteSUM As "Coste Registro ()"
      FROM DW_H_TRAMITESPRODUCTOS R
      LEFT OUTER JOIN DW_D_TIEMPO T ON T.IdTiempo = R.IdTiempo
      LEFT OUTER JOIN DW_D_PRODUCTO P ON P.IdProducto = R.IdProducto
      GROUP BY T.Ano, P.IdProducto, P.Nombre, R.CosteSUM
      ORDER BY 1, 4 DESC;

err_code := SQLCODE;

INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
Dbms_output.Put_line(Rsp);

Exception
     WHEN OTHERS THEN
     err_code := SQLCODE;
     Rsp := SUBSTR(' ERROR: ' || Sqlcode ||' ' || SQLERRM, 1, 50);
     Dbms_output.Put_line(Rsp);
     ROLLBACK;
     INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
END;
/

/*******************************************************************************
Nombre :   SP_PKDW_INF_TRAMITES
Paquete:   PKDW
Funcion:   Obtiene los paises donde los tramites son mas lentos, por ao
********************************************************************************/
CREATE OR REPLACE PROCEDURE SP_PKDW_INF_TRAMITES(
  VRecordset Out SYS_REFCURSOR,
  Rsp Out Nocopy Varchar2)
IS
param_input Varchar2(300); 
err_code Integer;
BEGIN 
param_input := '' ;
Rsp := 'OK';
OPEN VRecordset FOR 
  SELECT T.Ano, P.Nombre As Pais, R.DuracionSum As "DURACION TRAMITES"
  FROM DW_H_TRAMITESPAISES R
  LEFT OUTER JOIN DW_D_TIEMPO T ON T.IdTiempo = R.IdTiempo
  LEFT OUTER JOIN DW_D_PAIS P ON P.IdPais = R.IdPais
  GROUP BY T.Ano, P.Nombre, R.DuracionSum
  ORDER BY 1, 3 DESC;

err_code := SQLCODE;

INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
Dbms_output.Put_line(Rsp);

Exception
     WHEN OTHERS THEN
     err_code := SQLCODE;
     Rsp := SUBSTR(' ERROR: ' || Sqlcode ||' ' || SQLERRM, 1, 50);
     Dbms_output.Put_line(Rsp);
     ROLLBACK;
     INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
END;
/

/*******************************************************************************
Nombre :   SP_PKDW_INF_DURMEDIAPROD
Paquete:   PKDW
Funcion:   Obtiene los tiempos medios de registro por producto y ao
********************************************************************************/
CREATE OR REPLACE PROCEDURE SP_PKDW_INF_DURMEDIAPROD(
  VRecordset Out SYS_REFCURSOR,
  Rsp Out Nocopy Varchar2)
IS
param_input Varchar2(300); 
err_code Integer;
BEGIN 
param_input := '' ;
Rsp := 'OK';
OPEN VRecordset FOR 
  SELECT T.Ano, P.Nombre As Producto, R.DuracionMedia AS "DURACION MEDIA DE REGISTRO"
  FROM DW_H_TRAMITESPRODUCTOS R
  LEFT OUTER JOIN DW_D_TIEMPO T ON T.IdTiempo = R.IdTiempo
  LEFT OUTER JOIN DW_D_PRODUCTO P ON P.IdProducto = R.IdProducto
  GROUP BY T.Ano, P.Nombre, R.DuracionMedia
  ORDER BY 3 DESC;

err_code := SQLCODE;

INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
Dbms_output.Put_line(Rsp);

Exception
     WHEN OTHERS THEN
     err_code := SQLCODE;
     Rsp := SUBSTR(' ERROR: ' || Sqlcode ||' ' || SQLERRM, 1, 50);
     Dbms_output.Put_line(Rsp);
     ROLLBACK;
     INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
END;
/

/*******************************************************************************
Nombre :   SP_PKDW_INF_DURMEDIAPAIS
Paquete:   PKDW
Funcion:   Obtiene los tiempos medios de registro por pais y ao
********************************************************************************/
CREATE OR REPLACE PROCEDURE SP_PKDW_INF_DURMEDIAPAIS(
  VRecordset Out SYS_REFCURSOR,
  Rsp Out Nocopy Varchar2)
IS
param_input Varchar2(300); 
err_code Integer;
BEGIN 
param_input := '' ;
Rsp := 'OK';
OPEN VRecordset FOR 
  SELECT T.Ano, P.Nombre As Pais, R.DuracionMedia AS "DURACION MEDIA DE REGISTRO"
  FROM DW_H_TRAMITESPAISES R
  LEFT OUTER JOIN DW_D_TIEMPO T ON T.IdTiempo = R.IdTiempo
  LEFT OUTER JOIN DW_D_PAIS P ON P.IdPais = R.IdPais
  GROUP BY T.Ano, P.Nombre, R.DuracionMedia
  ORDER BY 3 DESC;

err_code := SQLCODE;

INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
Dbms_output.Put_line(Rsp);

Exception
     WHEN OTHERS THEN
     err_code := SQLCODE;
     Rsp := SUBSTR(' ERROR: ' || Sqlcode ||' ' || SQLERRM, 1, 50);
     Dbms_output.Put_line(Rsp);
     ROLLBACK;
     INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
END;
/

/*******************************************************************************
Nombre :   SP_PKDW_INF_REGSMEDPAIS
Paquete:   PKDW
Funcion:   Obtiene la media de los registros efectuados en cada pais, por ao
********************************************************************************/
CREATE OR REPLACE PROCEDURE SP_PKDW_INF_REGSMEDPAIS(
  VRecordset Out SYS_REFCURSOR,
  Rsp Out Nocopy Varchar2)
IS
param_input Varchar2(300); 
err_code Integer;
BEGIN 
param_input := '' ;
Rsp := 'OK';
OPEN VRecordset FOR 
  SELECT T.Ano, P.Nombre As Pais, R.RegistrosMedia As "Media De Registros"
  FROM DW_H_TRAMITESPAISES R
  LEFT OUTER JOIN DW_D_TIEMPO T ON T.IdTiempo = R.IdTiempo
  LEFT OUTER JOIN DW_D_PAIS P ON P.IdPais = R.IdPais
  GROUP BY T.Ano, P.Nombre, R.RegistrosMedia
  ORDER BY 1, 2;

err_code := SQLCODE;

INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
Dbms_output.Put_line(Rsp);

Exception
     WHEN OTHERS THEN
     err_code := SQLCODE;
     Rsp := SUBSTR(' ERROR: ' || Sqlcode ||' ' || SQLERRM, 1, 50);
     Dbms_output.Put_line(Rsp);
     ROLLBACK;
     INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
END;
/

/***************************************************************************************************
Nombre :   SP_PKDW_INF_PAISSINDISTRIB
Paquete:   PKDW
Funcion:   Obtiene el porcentaje de paises que no tienen distribuidor asociado en el momento actual
****************************************************************************************************/
CREATE OR REPLACE PROCEDURE SP_PKDW_INF_PAISSINDISTRIB(
  Salida OUT VARCHAR2,
  Rsp OUT Nocopy VARCHAR2)
IS
  param_input VARCHAR2(300); 
  err_code INTEGER;
  v_ano 	integer;
  v_trimestre 	integer;
  v_mes 	integer;
  v_idTiempo 	integer;
  v_porcentaje  float(2);

BEGIN 

  param_input := '' ;
  Rsp := 'OK';

  -- Extraemos el ao y mes de la fecha actual --
  SELECT EXTRACT(Year FROM SYSDATE) INTO v_ano FROM DUAL;
  SELECT EXTRACT(Month FROM SYSDATE) INTO v_mes FROM DUAL;
        
  -- Calculo del trimestre --
  v_trimestre := TRUNC((v_mes + 2) / 3);

  -- Obtenemos el identificador de Tiempo correspondiente al mes y ao actual --
  BEGIN
     v_idTiempo := -1;
     SELECT IdTiempo INTO v_idTiempo FROM DW_D_TIEMPO WHERE Mes = v_mes AND Trimestre = v_trimestre AND Ano = v_ano;
     
  EXCEPTION 
     WHEN NO_DATA_FOUND THEN
        IF v_idTiempo = -1 THEN
           INSERT INTO DW_D_TIEMPO (Ano, Trimestre, Mes) VALUES (v_ano, v_trimestre, v_mes) RETURNING IdTiempo INTO v_idTiempo;
        END IF;
  END;  

  -- Obtenemos el porcentaje --
  SELECT 100 - (ConDistribuidor * 100 / Total) INTO v_porcentaje FROM DW_H_PAISES WHERE IdTiempo = v_idTiempo;

  -- Generamos la salida --
  Salida := 'Paises sin distribuidor asociado: ' || TO_CHAR(v_porcentaje) || ' %';
  err_code := SQLCODE; 
  Dbms_output.Put_line(Salida);

  INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
  Dbms_output.Put_line(Rsp);

Exception
   WHEN OTHERS THEN
   err_code := SQLCODE;
   Rsp := SUBSTR(' ERROR: ' || Sqlcode ||' ' || SQLERRM, 1, 50);
   Dbms_output.Put_line(Rsp);
   ROLLBACK;
   INSERT INTO TFGBDJBD.LOGDW (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
END;
/

/**************************************************************************************
Nombre :   SP_PKDW_INF_FORMATOSNOREG
Paquete:   PKDW
Funcion:   Obtiene el porcentaje de formatos de producto que no se han registrado nunca
***************************************************************************************/
CREATE OR REPLACE PROCEDURE SP_PKDW_INF_FORMATOSNOREG(
  Salida OUT VARCHAR2,
  Rsp OUT Nocopy VARCHAR2)
IS
  param_input VARCHAR2(300); 
  err_code INTEGER;
  v_ano 	integer;
  v_trimestre 	integer;
  v_mes 	integer;
  v_idTiempo 	integer;
  v_porcentaje  float(2);

BEGIN 

   param_input := '' ;
   Rsp := 'OK';

   -- Extraemos el ao y mes de la fecha actual --
   SELECT EXTRACT(Year FROM SYSDATE) INTO v_ano FROM DUAL;
   SELECT EXTRACT(Month FROM SYSDATE) INTO v_mes FROM DUAL;
        
   -- Calculo del trimestre --
   v_trimestre := TRUNC((v_mes + 2) / 3);

   -- Obtenemos el identificador de Tiempo correspondiente al mes y ao actual --
   BEGIN
     v_idTiempo := -1;
     SELECT IdTiempo INTO v_idTiempo FROM DW_D_TIEMPO WHERE Mes = v_mes AND Trimestre = v_trimestre AND Ano = v_ano;
     
   EXCEPTION 
     WHEN NO_DATA_FOUND THEN
        IF v_idTiempo = -1 THEN
           INSERT INTO DW_D_TIEMPO (Ano, Trimestre, Mes) VALUES (v_ano, v_trimestre, v_mes) RETURNING IdTiempo INTO v_idTiempo;
        END IF;
   END;  


   -- Obtenemos el porcentaje --
   SELECT 100 - (Registrados * 100) / Total INTO v_porcentaje FROM DW_H_FORMATOS WHERE IdTiempo = v_idTiempo;

   -- Generamos la salida --
   Salida := 'Formatos de productos que nunca se han registrado: ' || TO_CHAR(v_porcentaje) || '%';
   Dbms_output.Put_line(Salida);
   err_code := SQLCODE;

   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
   Dbms_output.Put_line(Rsp);

Exception
   WHEN OTHERS THEN
   err_code := SQLCODE;
   Rsp := SUBSTR(' ERROR: ' || Sqlcode ||' ' || SQLERRM, 1, 50);
   Dbms_output.Put_line(Rsp);
   ROLLBACK;
   INSERT INTO TFGBDJBD.LOG (SP, PARAMETROS, RSP, ERRORCODE) VALUES ($$PLSQL_UNIT, SUBSTR(param_input,1,300), Rsp, err_code);
END;
/

COMMIT;

