/******************************************************************************/
/*   Script para realizar el test de las tablas y procedimientos almacenados  */
/*   de la BD y del DW                                                        */
/******************************************************************************/
set serveroutput on;

DECLARE 

RSP VARCHAR2 (150);
Valor LONG;

BEGIN
  
  /********************** TEST DE LA TABLA PAIS *******************************/
  SP_PKBD_PAIS_INS('Pais de Prueba1','TT',RSP);                                                     -- TEST 001
  SP_PKBD_PAIS_INS('Pais de Prueba1','ES',RSP);                                                     -- TEST 002
  SP_PKBD_PAIS_INS('Pais de Prueba1','ESS',RSP);                                                    -- TEST 003
  SP_PKBD_PAIS_UPD(16, 'Pais de Prueba1 Modificado','TT',RSP);                                      -- TEST 004
  SP_PKBD_PAIS_UPD(1000, 'Pais de Prueba1 Modificado','TT',RSP);                                    -- TEST 005
  SP_PKBD_PAIS_UPD(16, 'Pais de Prueba1 Modificado','ES',RSP);                                      -- TEST 006
  SP_PKBD_PAIS_DEL(1000, RSP);                                                                      -- TEST 007 
  SP_PKBD_PAIS_DEL(16, RSP);                                                                        -- TEST 008 
  SP_PKBD_PAIS_DEL(16, RSP);                                                                        -- TEST 009
  /****************************************************************************/

  /********************** TEST DE LA TABLA ENVASE *****************************/
  SP_PKBD_ENVASE_INS('Envase de Prueba', RSP);                                                      -- TEST 010
  SP_PKBD_ENVASE_INS(null, RSP);                                                                    -- TEST 011
  SP_PKBD_ENVASE_UPD(9, 'Envase de Prueba Modificado', RSP);                                        -- TEST 012
  SP_PKBD_ENVASE_UPD(1000, 'Envase de Prueba Modificado', RSP);                                     -- TEST 013
  SP_PKBD_ENVASE_DEL(1000, RSP);                                                                    -- TEST 014 
  SP_PKBD_ENVASE_DEL(9, RSP);                                                                       -- TEST 015 
  SP_PKBD_ENVASE_DEL(9, RSP);                                                                       -- TEST 016
  /****************************************************************************/
  
  /***************** TEST DE LA TABLA DISTRIBUIDOR ****************************/
  SP_PKBD_DISTRIBUIDOR_INS('Distribuidor de Prueba','C/Test','933333333', RSP);                     -- TEST 017
  SP_PKBD_DISTRIBUIDOR_INS(null, 'C/Test', '933333333', RSP);                                       -- TEST 018
  SP_PKBD_DISTRIBUIDOR_INS('Distribuidor de Prueba', 'C/Test', '9333333333', RSP);                  -- TEST 019
  SP_PKBD_DISTRIBUIDOR_UPD(6, 'Distribuidor de Prueba Modificado', 'C/Test', '933333333', RSP);     -- TEST 020
  SP_PKBD_DISTRIBUIDOR_UPD(1000, 'Distribuidor de Prueba Modificado', 'C/Test', '933333333', RSP);  -- TEST 021
  SP_PKBD_DISTRIBUIDOR_DEL(1000, RSP);                                                              -- TEST 022 
  SP_PKBD_DISTRIBUIDOR_DEL(1, RSP);                                                                 -- TEST 023
  SP_PKBD_DISTRIBUIDOR_DEL(6, RSP);                                                                 -- TEST 024 
  SP_PKBD_DISTRIBUIDOR_DEL(6, RSP);                                                                 -- TEST 025
  /****************************************************************************/

  /******************** TEST DE LA TABLA ESTADO *******************************/
  SP_PKBD_ESTADO_INS('4 - Estado de Prueba', RSP);                                                  -- TEST 026
  SP_PKBD_ESTADO_INS(null, RSP);                                                                    -- TEST 027
  SP_PKBD_ESTADO_UPD(4, '4 - Estado de Prueba Modificado', RSP);                                    -- TEST 028
  SP_PKBD_ESTADO_UPD(1000, '4 - Estado de Prueba Modificado', RSP);                                 -- TEST 029
  SP_PKBD_ESTADO_DEL(1000, RSP);                                                                    -- TEST 030 
  SP_PKBD_ESTADO_DEL(1, RSP);                                                                       -- TEST 031
  SP_PKBD_ESTADO_DEL(4, RSP);                                                                       -- TEST 032 
  SP_PKBD_ESTADO_DEL(4, RSP);                                                                       -- TEST 033
  /****************************************************************************/

  /******************** TEST DE LA TABLA FORMATO ******************************/
  SP_PKBD_FORMATO_INS('Formato de Prueba', 1, '1 ud', RSP);                                         -- TEST 034
  SP_PKBD_FORMATO_INS(null, 1, '1 ud', RSP);                                                        -- TEST 035
  SP_PKBD_FORMATO_INS('Formato de Prueba', 1000, '1 ud', RSP);                                      -- TEST 036
  SP_PKBD_FORMATO_UPD(27, 'Formato de Prueba Modificado', 1, '1 ud', RSP);                          -- TEST 037
  SP_PKBD_FORMATO_UPD(1000, 'Formato de Prueba Modificado', 1, '1 ud', RSP);                        -- TEST 038
  SP_PKBD_FORMATO_UPD(27, null, 1, '1 ud', RSP);                                                    -- TEST 039
  SP_PKBD_FORMATO_DEL(1000, RSP);                                                                   -- TEST 040 
  SP_PKBD_FORMATO_DEL(1, RSP);                                                                      -- TEST 041
  SP_PKBD_FORMATO_DEL(27, RSP);                                                                     -- TEST 042 
  SP_PKBD_FORMATO_DEL(27, RSP);                                                                     -- TEST 043
  /****************************************************************************/

  /****************** TEST DE LA TABLA HOMOLOGACION ***************************/
  SP_PKBD_HOMOLOGAR_INS(1, 1, 2, null, 'Homologacion de Prueba', RSP);                              -- TEST 044
  SP_PKBD_HOMOLOGAR_INS(1, 1, 1, null, 'Homologacion de Prueba', RSP);                              -- TEST 045
  SP_PKBD_HOMOLOGAR_INS(1000, 1, 2, null, 'Homologacion de Prueba', RSP);                           -- TEST 046
  SP_PKBD_HOMOLOGAR_UPD(1, 1, 2, null, 'Homologacion de Prueba Modificada', RSP);                   -- TEST 047
  SP_PKBD_HOMOLOGAR_UPD(1000, 1, 2, null, 'Homologacion de Prueba Modificada', RSP);                -- TEST 048
  SP_PKBD_HOMOLOGAR_UPD(1, 1, 2, null, null, RSP);                                                  -- TEST 049
  SP_PKBD_HOMOLOGAR_DEL(1000, 1, 2, RSP);                                                           -- TEST 050 
  SP_PKBD_HOMOLOGAR_DEL(1, 1, 2, RSP);                                                              -- TEST 051
  /****************************************************************************/

  /*********************** TEST DE LA TABLA MARCA *****************************/
  SP_PKBD_MARCA_INS('Marca de Prueba', 'Laboratorio de Prueba', RSP);                               -- TEST 052
  SP_PKBD_MARCA_INS('Marca de Prueba', null, RSP);                                                  -- TEST 053
  SP_PKBD_MARCA_INS(null, 'Laboratorio de Prueba', RSP);                                            -- TEST 054
  SP_PKBD_MARCA_UPD(23, 'Marca de Prueba Modificada', 'Laboratorio de Prueba Modificado', RSP);     -- TEST 055
  SP_PKBD_MARCA_UPD(1000, 'Marca de Prueba Modificada', 'Laboratorio de Prueba Modificado', RSP);   -- TEST 056
  SP_PKBD_MARCA_UPD(23, 'Marca de Prueba Modificada', null, RSP);                                   -- TEST 057
  SP_PKBD_MARCA_DEL(1000, RSP);                                                                     -- TEST 058 
  SP_PKBD_MARCA_DEL(23, RSP);                                                                       -- TEST 059
  SP_PKBD_MARCA_DEL(23, RSP);                                                                       -- TEST 060
  SP_PKBD_MARCA_DEL(1, RSP);                                                                        -- TEST 061
  /****************************************************************************/
 
  /******************* TEST DE LA TABLA PRESENTACION **************************/
  SP_PKBD_PRESENTACION_INS('Presentacion de Prueba', 'Blanco', RSP);                                -- TEST 062
  SP_PKBD_PRESENTACION_INS('Presentacion de Prueba', null, RSP);                                    -- TEST 063
  SP_PKBD_PRESENTACION_INS(null, 'Blanco', RSP);                                                    -- TEST 064
  SP_PKBD_PRESENTACION_UPD(9, 'Presentacion de Prueba Modificada', 'Blanco', RSP);                  -- TEST 065
  SP_PKBD_PRESENTACION_UPD(1000, 'Presentacion de Prueba Modificada', 'Lab de Test', RSP);          -- TEST 066
  SP_PKBD_PRESENTACION_UPD(9, 'Presentacion de Prueba Modificada', null, RSP);                      -- TEST 067
  SP_PKBD_PRESENTACION_DEL(1000, RSP);                                                              -- TEST 068 
  SP_PKBD_PRESENTACION_DEL(9, RSP);                                                                 -- TEST 069
  SP_PKBD_PRESENTACION_DEL(9, RSP);                                                                 -- TEST 070
  SP_PKBD_PRESENTACION_DEL(1, RSP);                                                                 -- TEST 071
  /****************************************************************************/

  /******************** TEST DE LA TABLA PRODUCTO *****************************/
  SP_PKBD_PRODUCTO_INS('Producto de Prueba', 'H2O+2H3CO', 1, 1, 1, RSP);                            -- TEST 072
  SP_PKBD_PRODUCTO_INS(null, 'H2O+2H3CO', 1, 1, 1, RSP);                                            -- TEST 073
  SP_PKBD_PRODUCTO_INS('Producto de Prueba', null, 1, 1, 1, RSP);                                   -- TEST 074
  SP_PKBD_PRODUCTO_INS('Producto de Prueba', null, 1000, 1, 1, RSP);                                -- TEST 075
  SP_PKBD_PRODUCTO_INS('Producto de Prueba', null, 1, 1000, 1, RSP);                                -- TEST 076
  SP_PKBD_PRODUCTO_INS('Producto de Prueba', null, 1, 1, 1000, RSP);                                -- TEST 077
  SP_PKBD_PRODUCTO_UPD(25, 'Producto de Prueba Modificado', 'HJK1000', 1, 1, 1, RSP);               -- TEST 078
  SP_PKBD_PRODUCTO_UPD(1000, 'Producto de Prueba Modificado', 'HJK1000', 1, 1, 1, RSP);             -- TEST 079
  SP_PKBD_PRODUCTO_UPD(25, 'Producto de Prueba Modificado', 'HJK1000', 1000, 1, 1, RSP);            -- TEST 080
  SP_PKBD_PRODUCTO_UPD(25, 'Producto de Prueba Modificado', 'HJK1000', 1, 1000, 1, RSP);            -- TEST 081
  SP_PKBD_PRODUCTO_UPD(25, 'Producto de Prueba Modificado', 'HJK1000', 1, 1, 1000, RSP);            -- TEST 082
  SP_PKBD_PRODUCTO_UPD(25, 'Producto de Prueba Modificado', null, 1, 1, 1000, RSP);                 -- TEST 083
  SP_PKBD_PRODUCTO_UPD(25, null, 'HJK1000', 1, 1, 1000, RSP);                                       -- TEST 084
  SP_PKBD_PRODUCTO_DEL(1000, RSP);                                                                  -- TEST 085
  SP_PKBD_PRODUCTO_DEL(1, RSP);                                                                     -- TEST 086
  SP_PKBD_PRODUCTO_DEL(6, RSP);                                                                     -- TEST 087 
  SP_PKBD_PRODUCTO_DEL(25, RSP);                                                                    -- TEST 088
  SP_PKBD_PRODUCTO_DEL(25, RSP);                                                                    -- TEST 089
  /****************************************************************************/

  /******************** TEST DE LA TABLA REGISTRO *****************************/
  SP_PKBD_REGISTRAR_INS(3, 2, 5, 'Insercion desde Testing', 1000, RSP);                             -- TEST 090
  SP_PKBD_REGISTRAR_INS(1000, 2, 1, 'Registro de Pruebas 06', 1000, RSP);                           -- TEST 091
  SP_PKBD_REGISTRAR_INS(3, 2, 5, 'Insercion desde Testing', 1000, RSP);                             -- TEST 092
  SP_PKBD_REGISTRAR_UPD(1000, 2, 1, SYSDATE, 2, RSP);                                               -- TEST 093
  SP_PKBD_REGISTRAR_UPD(3, 2, 5, SYSDATE, 2, RSP);                                                  -- TEST 094
  SP_PKBD_REGISTRAR_UPD(3, 2, 1000, SYSDATE, 2, RSP);                                               -- TEST 095
  /****************************************************************************/

COMMIT;

END;

